

/*

  Spirit Rover Robot
  Spirit_BaseSketch_Rev01
  Version 1.1 10/2017

  Significant portions of this code written by
  Dustin Soodak for Plum Geek LLC. Some portions
  contributed by Kevin King.
  Portions from other open source projects where noted.
  This code is licensed under:
  Creative Commons Attribution-ShareAlike 2.0 Generic (CC BY-SA 2.0)
  https://creativecommons.org/licenses/by-sa/2.0/
  Visit http://www.plumgeek.com for PiSpirit information.
  Visit http://www.arduino.cc to learn about the Arduino.

*/

#include "Hardware.h"

struct color {
  byte red;
  byte green;
  byte blue;
};

int theBrightness = 25;

void setup() {

  // ************ THE SETUP ITEMS BELOW SHOULD GENERALLY BE USED FOR ALL SPIRIT SKETCHES **************

  hardwareBegin();                    //initialize Spirit's Arduino processor to work with his circuitry
  SPI_Reset();                        //resets and turns on the SPI port
  playStartChirp();                   //Play startup chirp and blink eyes
  servoCenters();                     //Place all servos back in default position

  // ************ THE SETUP ITEMS BELOW CAN BE CUSTOMIZED FOR YOUR SPECIFIC SPIRIT SKETCH **************


  // add your own setup code here

  PIC_RangefinderEnable();
  Serial.begin(57600);
}


void loop() {

  // add your own loop code here

  PIC_ReadPower();
  Serial.print("Current: ");
  Serial.println(powerCurrent);


  for (int i = 0; i <= 255; i++) {
    for (int j = 0; j <= 26; j++) {
      struct color myColor = colorWheel((i*1+j*8)%255, theBrightness);
      setPixelRGB(j,myColor.red, myColor.green, myColor.blue);
    }
    RefreshPixels();
    delay(0);
  }

} // end of loop() function

struct color colorWheel(byte WheelPos, byte brightness) {
  struct color theColor;
  if (WheelPos < 85) {
    theColor.red  = map(255 - WheelPos * 3, 0, 255, 0, brightness);
    theColor.green = 0;
    theColor.blue = map(WheelPos * 3, 0, 255, 0, brightness);
  } else if (WheelPos < 170) {
    WheelPos -= 85;
    theColor.red = 0;
    theColor.green = map(WheelPos * 3, 0, 255, 0, brightness);
    theColor.blue = map(255 - WheelPos * 3, 0, 255, 0, brightness);
  } else {
    WheelPos -= 170;
    theColor.red = map(WheelPos * 3, 0, 255, 0, brightness);
    theColor.green = map(255 - WheelPos * 3, 0, 255, 0, brightness);
    theColor.blue = 0;
  }
  return theColor;
}




